#!/bin/sh

bus_address=unix:path=/tmp/var/run/mbusd/mbusd_socket

if [ $# -eq 0 ]
then
    echo "invalid params. following is supported command"
    echo "\n"
    echo "\tmbus listname"
    echo "\tmbus monitor"
fi


# list active modules
if [ "$1" =  "listname" ] || [ "$1" = "listnames" ]
then
    dbus-send --bus=$bus_address \
                    --print-reply --dest=org.freedesktop.DBus \
                    /org/freedesktop/DBus org.freedesktop.DBus.ListNames
    exit
fi


# monitor bus traffic flow
# ./mbus.sh monitor --profile
if [ "$1" =  "monitor" ]
then
    shift
    dbus-monitor --address $bus_address $@
    exit
fi

# Introspect bus object
# ./mbus.sh introspect well.known.name
if [ "$1" = "introspect" ]; then
    shift
    dbus-send --bus=$bus_address --print-reply=literal --dest=$1 / org.freedesktop.DBus.Introspectable.Introspect
    exit
fi

# call function
# ./mbush.sh call well.known.name interface method  [ arguments ]
if [ "$1" = "call" ]; then
    shift
    wkn=$1
    shift
    interface=$1
    shift
    method=$1
    shift
    dbus-send --bus=$bus_address --print-reply=literal --dest=$wkn / $interface.$method $@
    exit
fi
